#include <avr/pgmspace.h>

#define X1PIN 0
#define Y1PIN 1
#define X2PIN 2
#define Y2PIN 3
#define LEDPIN 11 // Teensy 2.0

static HardwareSerial Uart; // Teensy 2.0

static const byte parity[] PROGMEM = { 32, 0, 0, 32, 0, 32, 32, 0, 0, 32, 32, 0, 32, 0, 0, 32, 0, 32, 32, 0, 32, 0, 0, 32, 32, 0, 0, 32, 0, 32, 32, 0 };

static void blink();

void setup() {
    //Serial.begin( 2400 );
    Uart.begin( 2400 );
    pinMode( LEDPIN, OUTPUT );
    digitalWrite( LEDPIN, HIGH );
}

static int xPin = X1PIN;
static int yPin = Y1PIN;
static int wPin = X2PIN;

void loop() {
    const int option = analogRead( Y2PIN );
    if ( option == 0 ) {
        xPin = X1PIN; // crab drive
        wPin = X2PIN;
        blink();
    } else if ( option == 1023 ) {
        xPin = X2PIN; // tank drive
        wPin = X1PIN;
        blink();
    }
    // pvvvvvnn    p: odd parity | v: value | nn: number (x=00, y=01, w=10)
    byte x = ( analogRead( xPin ) + 16 ) >> 5;
    if ( x > 31 ) {
        x = 31;
    }
    x |= pgm_read_byte( &parity[ x ] );
    x = ( x << 2 ) | 0b00;
    Uart.print( x, BYTE );
    //Serial.print( x, BIN ); Serial.print( " " );

    byte y = ( analogRead( yPin ) + 16 ) >> 5;
    if ( y > 31 ) {
        y = 31;
    }
    y |= pgm_read_byte( &parity[ y ] );
    y = ( y << 2 ) | 0b01;
    Uart.print( y, BYTE );
    //Serial.print( y, BIN ); Serial.print( " " );

    byte w = ( analogRead( wPin ) + 16 ) >> 5;
    if ( w > 31 ) {
        w = 31;
    }
    w |= pgm_read_byte( &parity[ w ] );
    w = ( w << 2 ) | 0b10;
    Uart.print( w, BYTE );
    //Serial.print( w, BIN ); Serial.print( "\n" );
    //delay( 200 );
}

static void blink()
{
    for ( int i = 0; i < 5; ++i ) {
        digitalWrite( LEDPIN, LOW );
        delay( 50 );
        digitalWrite( LEDPIN, HIGH );
        delay( 50 );
    }
}
